﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 5.2
// Code is generated on: 
// Code is generated using templates: SD.TemplateBindings.SharedTemplates
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace Test.HelperClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	
	/// <summary>Singleton implementation of the FieldInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.</summary>
	/// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the FieldInfoProviderBase class is threadsafe.</remarks>
	internal static class FieldInfoProviderSingleton
	{
		#region Class Member Declarations
		private static readonly IFieldInfoProvider _providerInstance = new FieldInfoProviderCore();
		#endregion

		/// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
		static FieldInfoProviderSingleton()
		{
		}

		/// <summary>Gets the singleton instance of the FieldInfoProviderCore</summary>
		/// <returns>Instance of the FieldInfoProvider.</returns>
		public static IFieldInfoProvider GetInstance()
		{
			return _providerInstance;
		}
	}

	/// <summary>Actual implementation of the FieldInfoProvider. Used by singleton wrapper.</summary>
	internal class FieldInfoProviderCore : FieldInfoProviderBase
	{
		/// <summary>Initializes a new instance of the <see cref="FieldInfoProviderCore"/> class.</summary>
		internal FieldInfoProviderCore()
		{
			Init();
		}

		/// <summary>Method which initializes the internal datastores.</summary>
		private void Init()
		{
			this.InitClass();
			InitClientEntityInfos();

			this.ConstructElementFieldStructures(InheritanceInfoProviderSingleton.GetInstance());
		}

		/// <summary>Inits ClientEntity's FieldInfo objects</summary>
		private void InitClientEntityInfos()
		{
			this.AddFieldIndexEnumForElementName(typeof(ClientFieldIndex), "ClientEntity");
			this.AddElementFieldInfo("ClientEntity", "City", typeof(System.String), false, false, false, true,  (int)ClientFieldIndex.City, 255, 0, 0);
			this.AddElementFieldInfo("ClientEntity", "DateIn", typeof(System.DateTime), false, false, false, false,  (int)ClientFieldIndex.DateIn, 0, 0, 0);
			this.AddElementFieldInfo("ClientEntity", "Id", typeof(System.Int32), true, false, true, false,  (int)ClientFieldIndex.Id, 0, 0, 11);
			this.AddElementFieldInfo("ClientEntity", "Level", typeof(System.Int32), false, false, false, false,  (int)ClientFieldIndex.Level, 0, 0, 11);
			this.AddElementFieldInfo("ClientEntity", "Name", typeof(System.String), false, false, false, true,  (int)ClientFieldIndex.Name, 50, 0, 0);
			this.AddElementFieldInfo("ClientEntity", "Principal", typeof(System.Boolean), false, false, false, false,  (int)ClientFieldIndex.Principal, 0, 0, 1);
		}
		
	}
}




