﻿using System;
using Wisej.Web;

namespace TestWisej
{
    public partial class Window2 : Form
    {
        Test.HelperClasses.EntityCollection<Test.EntityClasses.ClientEntity> Items = new Test.HelperClasses.EntityCollection<Test.EntityClasses.ClientEntity>();

        public Window2()
        {
            InitializeComponent();
        }

        private void Window2_Load(object sender, EventArgs e)
        {
            LoadData();
            bindingSource1.DataSource = Items;
        }

        private void LoadData()
        {
            Test.EntityClasses.ClientEntity Item = new Test.EntityClasses.ClientEntity();
            Item.Id = 1;
            Item.Name = "Person One";
            Item.DateIn = DateTime.Now;
            Item.Level = 45;
            Item.Principal = false;
            Item.City = "Santa Cruz";
            Items.Add(Item);

            Item = new Test.EntityClasses.ClientEntity();
            Item.Id = 2;
            Item.Name = "Person Two";
            Item.DateIn = DateTime.Now.AddDays(-5);
            Item.Level = 12;
            Item.Principal = true;
            Item.City = "Truk";
            Items.Add(Item);

            Item = new Test.EntityClasses.ClientEntity();
            Item.Id = 3;
            Item.Name = "Person Three";
            Item.DateIn = DateTime.Now.AddDays(-15);
            Item.Level = 78;
            Item.Principal = false;
            Item.City = "Kwai";
            Items.Add(Item);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            dataGridView1.Sort(dataGridView1.Columns[0], System.ComponentModel.ListSortDirection.Descending);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            bindingSource1.Sort = "Id Desc";
        }

      
    }
}
